/*
 * TreeOneByOne.ino For ATtiny 13 
 *
 * Created: 26/07/2015 14:42:12 Arduino 1.06
 *  Author: Mic-Josi 
 * Attiny13
 * for Tiny Tree Rev. 1.1 and 1.7 PCB
 * pour Tiny Tree Rev. 1.1 et 1.7
 * configuration sélection oscillateur interne 4.8 Mhz et division par 8 coupure alimentation à 1.8 Volts
 * setting internal oscillator 4,8 MHz and division by 8 selected brown-out level detection at 1.8 Volts
 * FuseBits: Low = 0x69 Hight = 0xFD 
 *le programmme compilé ne doit pas dépasser 875 octets sinon blocage
 * the compiled program may exceed 875 bytes if it crashes
 */

 
/*
These inused #define are for using with Amtel Studio 6 only
Ces defines sont à utiliser uniquement avec Amtel Studio 6 
# define __DELAY_BACKWARD_COMPATIBLE__ 
# define F_CPU 8000000UL
# include <avr/io.h>
# include <util/delay.h>
# define byte uint8_t
*/

//Arduino defines
#include <avr/pgmspace.h>
#define LED_COUNT 9
#define DDR_BYTE 0
#define PORT_BYTE 1


const byte matrix[LED_COUNT][2] PROGMEM = {
	
	// DDR_BYTE   	PORT_BYTE                                        
	{0b00010001	, 0b00010000},//L0-PB4               0                 
	{0b00010001	, 0b00000001},//L1-PB4           "     "                   
	{0b00001001	, 0b00001000},//L2-PB3          " 1    2 "               **     Pin-Tree     **
	{0b00001001	, 0b00000001},//L3-PB3        "      3     "                 L0+ L1- Pin 3
	{0b00000101	, 0b00000100},//L4-PB2      " 4            6 "               L2+ L3- Pin 2
	{0b00000101	, 0b00000001},//L5-PB2     "                   "             L4+ L5- Pin 7
	{0b00000011	, 0b00000010},//L6-PB1    " 5                 7  "           L6+ L7- Pin 6
	{0b00000011	, 0b00000001},//L7-PB1   """""""""""""""""""""""""""   ** +- Commun PB0 Pin 5 **
          
};		


//*******************************************************
void turnOn( byte led ) // PBx selection
{
  DDRB = pgm_read_byte (&( matrix[led][DDR_BYTE]));
  PORTB = pgm_read_byte (&(matrix[led][PORT_BYTE]));
}
//*******************************************************


//*******************************************************
// frame- nombre de fois la figure, l1 à l8 = état des LED, spd = temps d'llumage d'une LED en mili-second
void SomeOne (byte frame,byte l1,byte l2,byte l3,byte l4,byte l5,byte l6,byte l7,byte l8,byte spd) // some LEDs ON one by one spd time
{  
	
    int figure [9]= {0,0,0,0,0,0,0,0,0};
	
	int light = 0;
	int allume = 0;
	byte l9 = 8;
	while (light < frame)
	{
		for( byte l = 0; l < LED_COUNT; l++ )
		
	  	{
			switch (l)
			{
			case 0:
			figure [l] = l1;
			break;	
			
			case 1:
			figure [l] = l2;
			break;
			
			case 2:
			figure [l] = l3;
			break;
			
			case 3:
			figure [l] = l4;
			break;
			
			case 4:
			figure [l] = l5;
			break;
			
			case 5:
			figure [l] = l6;
			break;
			
			case 6:
			figure [l] = l7;
			break;
			
			case 7:
			figure [l] = l8;
			break;
			
			case 8:
			figure [l] = l9;
			break;
			} 
			
			
		}
		for( byte l = 0; l < LED_COUNT; l++ )
		{
		 allume = figure[l];
		 turnOn(allume);
		 delay(spd);
		} 
		
		light ++;
	}
	delay(50);

}

 //*******************************************************



void setup()
{
}


//*******************************************************

//=======================================================
void loop()
{
  /* 0 à 7 emplacement d'allumage de la LED,8 LED éteinte
    0 to 7 lighting location of the LED, 8 LED off */
  
  SomeOne (8,0,1,2,3,4,6,5,7,150); // une par une tres lent
  SomeOne (8,0,1,2,3,4,6,5,7,65); // une par une moyen
  SomeOne (15,0,1,2,3,4,6,5,7,25); // une par une rapide
  SomeOne (90,0,1,2,3,4,5,6,7,1);  // flash
  SomeOne (8,0,1,2,8,8,8,8,8,70);// petit triangle haut lent
  SomeOne (8,1,2,3,8,1,2,3,8,49);// petit triangle haut inversé lent0
  SomeOne (8,5,4,1,0,0,2,6,7,42); // grand triangle lent
  SomeOne (8,8,5,4,1,3,2,6,7,46); //grand M rapide
  SomeOne (8,1,2,6,4,3,8,8,0,35);     //trapèze&L4 Rapide
  SomeOne (10,0,1,2,8,4,5,6,7,40);    //grandTriangleparL1
  //  SomeOne (8,0,2,1,8,4,6,5,7,150);     //02184657


}

//=======================================================


